-- replaced getglobal
local MyShammy_lasttimecheck = 0
local MyShammy_Table = {
"Flame Shock",
"Unleash Elements",
"Lava Burst",
"Lightning Bolt",
"Chain Lightning",
"Frost Shock",
"Thunderstorm",
"Earth Shock",
}

function MyShammy_OnLoad(self)
	local _, class = UnitClass("player")
	if class ~= "SHAMAN" then
	MyShammyPanel:Hide()
	DisableAddOn("MyShammy")
	return
	end
	self:RegisterEvent("PLAYER_LOGIN")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")		
	self:RegisterEvent("ACTIONBAR_UPDATE_USABLE")
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN")
	
	SLASH_MyShammy1 = "/myshammy";
	SLASH_MyShammy2 = "/mys";
	SlashCmdList["MyShammy"] = MyShammy_SlashCommand;

	if ( DEFAULT_CHAT_FRAME ) then
	DEFAULT_CHAT_FRAME:AddMessage("MyShammy loaded.",1, 0, 0);
	end
end

function MyShammy_OnEvent(self, event, ...)
	if (event == "ACTIONBAR_UPDATE_USABLE" or event == "ACTIONBAR_UPDATE_COOLDOWN") then
	MyShammy_Cooldown() -- makes the cooldown effect
	end
end
function MyShammy_Timer(elapsed)
	MyShammy_lasttimecheck = MyShammy_lasttimecheck + elapsed
	if (MyShammy_lasttimecheck >= .1) then
	MyShammy_lasttimecheck = 0
		MyShammy_FlameShock_Check()
		if IsSpellInRange("Flame Shock", "target")==1 then
		MyShammy_Button1:SetAlpha(1.0)
		else MyShammy_Button1:SetAlpha(0.3)
		end
		if IsSpellInRange("Unleash Elements", "target")==1 then
		MyShammy_Button2:SetAlpha(1.0)
		else MyShammy_Button2:SetAlpha(0.3)
		end
		if IsSpellInRange("Lava Burst", "target")==1 then
		MyShammy_Button3:SetAlpha(1.0)
		else MyShammy_Button3:SetAlpha(0.3)
		end
		if IsSpellInRange("Lightning Bolt", "target")==1 then
		MyShammy_Button4:SetAlpha(1.0)
		else MyShammy_Button4:SetAlpha(0.3)
		end
		if IsSpellInRange("Chain Lightning", "target")==1 then
		MyShammy_Button5:SetAlpha(1.0)
		else MyShammy_Button5:SetAlpha(0.3)
		end
		if IsSpellInRange("Frost Shock", "target")==1 then
		MyShammy_Button6:SetAlpha(1.0)
		else MyShammy_Button6:SetAlpha(.3)
		end
		if IsSpellInRange("Thunderstorm", "target")==1 then
		MyShammy_Button7:SetAlpha(1.0)
		else MyShammy_Button7:SetAlpha(1)
		end
		if IsSpellInRange("Earth Shock", "target")==1 then
		MyShammy_Button8:SetAlpha(1.0)
		else MyShammy_Button8:SetAlpha(.3)
		end
		local	name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable  =  UnitBuff("player", "Lightning Shield")
		if count ~= nil then
		MyShammyPanel_Text:SetText(string.format("%2d",count))
		else MyShammyPanel_Text:SetText(" ")
		end
	end
end

function MyShammy_Cooldown() -- makes that cool cooldown effect
	for i=1, 8 do
	local usable, nomana = IsUsableSpell(MyShammy_Table[i])
		if usable then -- prevents lua nil error in Cooldown
		local cooldown = _G["MyShammy_Button"..i.."Cooldown"]
		local start, duration, enable = GetSpellCooldown(MyShammy_Table[i])
		CooldownFrame_SetTimer(cooldown, start, duration, enable)
		end
	end
end

function MyShammy_FlameShock_Check()
	MyShammy_Button9:SetAlpha(1.0)
	local	name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable  =  UnitDebuff("target", "Flame Shock")
	if expirationTime ~= nil then
	local MyShammy_Timeleft = expirationTime - GetTime()
		if MyShammy_Timeleft <.2 then
		MyShammy_Timeleft = 0
		MyShammy_Button9:SetAlpha(0.0)
		else MyShammy_Button9_Time:SetText(string.format("%2d",MyShammy_Timeleft))
		end
	else MyShammy_Button9:SetAlpha(0.0)
	end
end		
		
function  MyShammy_Out(text)
	DEFAULT_CHAT_FRAME:AddMessage(text)
end
    
function MyShammy_SlashCommand(msg)
	if msg == "bell" then
	PlaySoundFile("Sound\\Spells\\ShaysBell.wav")
	elseif msg == "" or msg == "help" then
	MyShammy_Out("Shift/Left Click and drag the edge to move the panel.")
	end
end